#include <windows.h>

extern "C" {

struct export {
	char *name;
	void *address;
};
/*

//We need to return our own version number to pass etqw xp check
BOOL WINAPI GetVersionEx_Hook(LPOSVERSIONINFO lpVersionInfo) {
	BOOL r = GetVersionEx(lpVersionInfo);
	lpVersionInfo->dwMajorVersion = 0x1337;
	lpVersionInfo->dwMinorVersion = 0xF001;
	return r;
}

//Don't be callin if you don't have imports
#define EVALRVA(type, x) ((type)((DWORD)hMod + (DWORD)(x)))
void SetImportAddress(HMODULE hMod, const char *module, const char *func, DWORD address) {
	PIMAGE_NT_HEADERS nt = EVALRVA(PIMAGE_NT_HEADERS, ((PIMAGE_DOS_HEADER)hMod)->e_lfanew);
	PIMAGE_DATA_DIRECTORY importdd = &nt->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_IMPORT];

	int nModules = importdd->Size / sizeof(IMAGE_IMPORT_DESCRIPTOR);

	PIMAGE_IMPORT_DESCRIPTOR importd = EVALRVA(PIMAGE_IMPORT_DESCRIPTOR, importdd->VirtualAddress);
	
	PIMAGE_THUNK_DATA firstThunk = NULL;
	PIMAGE_THUNK_DATA originalFirstThunk = NULL;

	for(int i = 0; i < nModules; i++) {
		const char *modname = EVALRVA(const char *, importd[i].Name);
		if(strcmp(module, modname) == 0) {
			firstThunk = EVALRVA(PIMAGE_THUNK_DATA, importd[i].FirstThunk);
			originalFirstThunk = EVALRVA(PIMAGE_THUNK_DATA, importd[i].OriginalFirstThunk);
			break;
		}
	}

	if(!firstThunk || !originalFirstThunk) return;

	for(int i = 0; originalFirstThunk[i].u1.AddressOfData; i++) {
		PIMAGE_IMPORT_BY_NAME import = EVALRVA(PIMAGE_IMPORT_BY_NAME, originalFirstThunk[i].u1.AddressOfData);
		if(strcmp((char *)import->Name, func) == 0) {
			DWORD oldProtect;
			VirtualProtect(&firstThunk[i].u1.AddressOfData, sizeof(DWORD), PAGE_EXECUTE_READWRITE, &oldProtect);
			firstThunk[i].u1.AddressOfData = address;
			VirtualProtect(&firstThunk[i].u1.AddressOfData, sizeof(DWORD), oldProtect, &oldProtect);
			break;
		}
	}
}
#undef EVALRVA
*/

//Exports from my wtsapi32.dll
const int numExports = 32;
struct export exports[numExports] = {
	{ "WTSCloseServer", NULL },
	{ "WTSDisconnectSession", NULL },
	{ "WTSEnumerateProcessesA", NULL },
	{ "WTSEnumerateProcessesW", NULL },
	{ "WTSEnumerateServersA", NULL },
	{ "WTSEnumerateServersW", NULL },
	{ "WTSEnumerateSessionsA", NULL },
	{ "WTSEnumerateSessionsW", NULL },
	{ "WTSFreeMemory", NULL },
	{ "WTSLogoffSession", NULL },
	{ "WTSOpenServerA", NULL },
	{ "WTSOpenServerW", NULL },
	{ "WTSQuerySessionInformationA", NULL },
	{ "WTSQuerySessionInformationW", NULL },
	{ "WTSQueryUserConfigA", NULL },
	{ "WTSQueryUserConfigW", NULL },
	{ "WTSSendMessageA", NULL },
	{ "WTSSendMessageW", NULL },
	{ "WTSSetSessionInformationA", NULL },
	{ "WTSSetSessionInformationW", NULL },
	{ "WTSSetUserConfigA", NULL },
	{ "WTSSetUserConfigW", NULL },
	{ "WTSShutdownSystem", NULL },
	{ "WTSTerminateProcess", NULL },
	{ "WTSVirtualChannelClose", NULL },
	{ "WTSVirtualChannelOpen", NULL },
	{ "WTSVirtualChannelPurgeInput", NULL },
	{ "WTSVirtualChannelPurgeOutput", NULL },
	{ "WTSVirtualChannelQuery", NULL },
	{ "WTSVirtualChannelRead", NULL },
	{ "WTSVirtualChannelWrite", NULL },
	{ "WTSWaitSystemEvent", NULL }
};

int _count_exports = 0;
#define ENTPOINT(x) int i##x = _count_exports++; \
	void __declspec(dllexport, naked) x () { \
		__asm { mov eax, i##x }; \
		__asm { mov eax, DWORD PTR [exports + eax*8 + 4] }; \
		__asm { jmp eax }; \
	}

ENTPOINT(WTSCloseServer)
ENTPOINT(WTSDisconnectSession)
ENTPOINT(WTSEnumerateProcessesA)
ENTPOINT(WTSEnumerateProcessesW)
ENTPOINT(WTSEnumerateServersA)
ENTPOINT(WTSEnumerateServersW)
ENTPOINT(WTSEnumerateSessionsA)
ENTPOINT(WTSEnumerateSessionsW)
ENTPOINT(WTSFreeMemory)
ENTPOINT(WTSLogoffSession)
ENTPOINT(WTSOpenServerA)
ENTPOINT(WTSOpenServerW)
ENTPOINT(WTSQuerySessionInformationA)
ENTPOINT(WTSQuerySessionInformationW)
ENTPOINT(WTSQueryUserConfigA)
ENTPOINT(WTSQueryUserConfigW)
ENTPOINT(WTSSendMessageA)
ENTPOINT(WTSSendMessageW)
ENTPOINT(WTSSetSessionInformationA)
ENTPOINT(WTSSetSessionInformationW)
ENTPOINT(WTSSetUserConfigA)
ENTPOINT(WTSSetUserConfigW)
ENTPOINT(WTSShutdownSystem)
ENTPOINT(WTSTerminateProcess)
ENTPOINT(WTSVirtualChannelClose)
ENTPOINT(WTSVirtualChannelOpen)
ENTPOINT(WTSVirtualChannelPurgeInput)
ENTPOINT(WTSVirtualChannelPurgeOutput)
ENTPOINT(WTSVirtualChannelQuery)
ENTPOINT(WTSVirtualChannelRead)
ENTPOINT(WTSVirtualChannelWrite)
ENTPOINT(WTSWaitSystemEvent)

BOOL WINAPI
WTSRegisterSessionNotification(
    HWND hWnd,
    DWORD dwFlags
	) {
	return TRUE;
}

BOOL WINAPI
WTSUnRegisterSessionNotification(
    HWND hWnd) {
	return TRUE;
}

BOOL WINAPI DllMain(
  HINSTANCE hinstDLL,
  DWORD fdwReason,
  LPVOID lpvReserved
  ) {
	  if(fdwReason == DLL_PROCESS_ATTACH) {
		  //LoadLibrary in DllMain is a no no according to MS. Seems to work ok though, something about
		  //dependencies getting out of wack.  Should be ok I guess since we are just loading a seperate dll
		  //for ourselves.
		  HMODULE hMod = LoadLibrary("wtsapi32_old.dll");
		  if(hMod) {
			for(int i = 0; i < numExports; i++) {
				exports[i].address = GetProcAddress(hMod, exports[i].name);
			}
		  }

		  //Hook getversion
		//  SetImportAddress(GetModuleHandle("etqw.exe"), "KERNEL32.dll", "GetVersionExA", (DWORD)GetVersionEx_Hook);
	  }
	  return TRUE;
}

}

